echo off
chcp 1252

REM Text für das Desktop-Icon, optional: aus Variable auslesen
REM set "QGIS_TEXT=QGIS %QGIS_VER%"
set "QGIS_TEXT=QGIS LTR"

REM Startmodus auswählen: wird der Parameter 1 mit "RUN" oder "run" übergeben, soll der "run"-Teil dieses Skripts ausgeführt werden, andernfalls wird der "prepare"-Teil durchlaufen
if #%1==#RUN goto run
if #%1==#run goto run

REM ==================================================================
REM PREPARE-Teil des Skripts ....
REM ==================================================================

REM Die Default-Einstellung für das Benutzer-Verzeichnis wird ignoriert und auf das Vorlagenverzeichnis gesetzt.
set "QGIS_UDIR=%OSGEO4W_ROOT%\qgis_template"

REM Batch-Datei für die spätere Verwendung in der "RUN"-Phase erstellen.
echo set "QGIS_PDIR_ORG=%OSGEO4W_ROOT%" >  %OSGEO4W_ROOT%\bin\qgis-orgdir.bat
echo set "QGIS_UDIR_ORG=%USERPROFILE%"  >> %OSGEO4W_ROOT%\bin\qgis-orgdir.bat

exit /b

:run
REM ==================================================================
REM RUN-Teil des Skripts ausführen....
REM ==================================================================

REM Wenn das Benutzerverzeichnis existiert ==> Qgis normal starten
if exist %QGIS_UDIR% goto start_qgis

REM ==================================================================
REM Erstmalige Nutzung von QGIS auf einem Benutzer-PC ==> Installation
REM des Benutzerverzeichnisses durchführen....
REM ==================================================================

echo Installiere das Verzeichnis für die Benutzereinstellungen........

REM Variablen für den Austausch der Verzeichnisnamen vorbereiten...
set "QGIS_PDIR_ORG=%OSGEO4W_ROOT%"
set "QGIS_UDIR_ORG=%USERPROFILE%"

REM Austausch Backslash zu Slash
set "PN=%OSGEO4W_ROOT:"=%"
set "PN=%PN:\=/%"

REM Austausch Backslash zu Slash
set "PO=%QGIS_PDIR_ORG:"=%"
set "PO=%PO:\=/%"

REM Austausch Backslash zu Slash
set "QO=%QGIS_UDIR_ORG:"=%"
set "QO=%QO:\=/%"

REM Austausch Backslash zu Slash
set "QN=%USERPROFILE:\=/%"

REM Austausch Backslash zu Slash
set "UN=%QGIS_UDIR:"=%"
set "UN=%UN:\=/%"

set "UO=%PO%/qgis_template"

echo off
REM Kopieren der Vorlage in das Benutzerverzeichnis des Anwenders 
xcopy "%PN%/qgis_template" "%UN%" /e /i

REM Original-Pfade der ini-Datei mit den Zielpfaden auf dem Anwender-PC ersetzen 
copy "%UN%\profiles\default\QGIS\QGIS3.ini" "%UN%\profiles\default\QGIS\QGIS3.org"
minised "s#%UO%#%UN%#g;s#%UO:/=\\\\%#%UN:/=\\\\%#g;s#%PO%#%PN%#g;s#%PO:/=\\\\%#%PN:/=\\\\%#g;s#%QO%#%QN%#g;s#%QO:/=\\\\%#%QN:/=\\\\%#g" "%UN%\profiles\default\QGIS\QGIS3.org" > "%UN%\profiles\default\QGIS\QGIS3.ini"

REM Verknüpfungen in der Programmgruppe für Benutzer erstellen 
if not exist "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS\%QGIS_TEXT%.lnk" (
   if not exist "%USERPROFILE%\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\QGIS\%QGIS_TEXT%.lnk" (
      nircmd shortcut """%OSGEO4W_ROOT%""\bin\qgis-ltr-start.bat" "~$folder.programs$\QGIS" "%QGIS_TEXT%" "" """%OSGEO4W_ROOT%""\icons\QGIS.ico" "0" "min" """%OSGEO4W_ROOT%""\bin" ""
	  )
   )

if not exist "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS\OSGeo4W Shell.lnk" (
   if not exist "%USERPROFILE%\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\QGIS\OSGeo4W Shell.lnk" (
      nircmd shortcut """%OSGEO4W_ROOT%""\OSGeo4W.bat" "~$folder.programs$\QGIS" "OSGeo4W Shell" "" """%OSGEO4W_ROOT%""\OSGeo4W.ico" "" "" """\" ""
      )
   )

REM Verknüpfung auf dem Desktop für den Benutzer erstellen 
if not exist "%PUBLIC%\Desktop\%QGIS_TEXT%.lnk" (
   if not exist "%USERPROFILE%\Desktop\%QGIS_TEXT%.lnk" (
      nircmd shortcut """%OSGEO4W_ROOT%""\bin\qgis-ltr-start.bat" "~$folder.desktop$" "%QGIS_TEXT%" "" """%OSGEO4W_ROOT%""\icons\QGIS.ico" "0" "min" """%OSGEO4W_ROOT%""\bin" ""
	  )
   )

:start_qgis
exit /b
